# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## 13.3.0 - 2022-09-02

### Changed

  - Aligned with MicroEJ Architecture UI 13.3.0.

### Added

  - [frontpanel] Add custom image formats in the `MicroUIImageFormat` enumeration and the `BufferedImageProvider` service to prepare for future MicroUI functionality.
  
## 13.2.0 - 2022-05-05

### Added

  - [frontpanel] Add `LLUIDisplayImpl.decode()` (the implementation can open encoded images).
  - [frontpanel] Add `LLUIDisplay.readPixel()`.
  - [imageGenerator] Allow to a custom image converter to generate a file other than a binary resource.
  - [imageGenerator] Allow to a custom image converter to specify the supported *.list files.

### Changed

  - Aligned with MicroEJ Architecture UI 13.2.0.

## 13.1.0 - 2021-08-03

### Added

  - [frontpanel] Add `MicroUIImage.getImage(int)` (apply a rendering color on Ax images). 
  - [frontpanel] Add `LLUIDisplay.convertRegion()` (convert a region according image format restrictions). 
  - [frontpanel] Add `LLUIDisplayImpl.waitFlush()` (the implementation can manage an asynchronous flush).

### Changed

  - Aligned with MicroEJ Architecture UI 13.1.0.
  - [frontpanel] Update Pointer event format. 

## 13.0.7 - 2021-07-30

### Changed

  - Aligned with MicroEJ Architecture UI 13.0.7.

## 13.0.6 - 2021-03-29

### Changed

  - Aligned with MicroEJ Architecture UI 13.0.6.

## 13.0.5 - 2021-03-08

### Changed

  - Aligned with MicroEJ Architecture UI 13.0.5.

## 13.0.4 - 2021-01-15

### Changed

  - Aligned with MicroEJ Architecture UI 13.0.4.

### Fixed

  - [imageGenerator] NullPointerException when trying to convert an unknown image.

## 13.0.3 - 2020-12-03

### Changed

  - Aligned with MicroEJ Architecture UI 13.0.3.

## 13.0.1 - 2020-09-22

### Fixed

  - [frontpanel] fillRectangle() parameters names are invalid.
  - [frontpanel] Missing LLAPI to check if destination region overlaps source region.
  
## 13.0.0 - 2020-07-30

### Added

  - Initial revision.
  - Publish frontpanel.jar and imagegenerator.jar (libraries to build a platform against UI pack 13.x)

### Changed 

  - `ej.tool.frontpanel#widget-microui` has been renamed in `com.microej.pack.ui#ui-pack(frontpanel)`. This library is fetched by transitivity when front panel project depends on `ej.tool.frontpanel#widget-2.0.0`. 
  - Image generator extension project has to use ivy dependency `com.microej.pack.ui#ui-pack(imageGenerator)` instead of classpath variable `IMAGE-GENERATOR-x.x`.

---
_Copyright 2020-2022 MicroEJ Corp. All rights reserved._  
_This library is provided in source code for use, modification and test, subject to license terms._  
_Any modification of the source code will break MicroEJ Corp. warranties on the whole library._
